#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <stddef.h>

#include "kolibri_libimg.h"
#include <kos32sys.h>


char proc_info[1024];
char temp_path[4096];
char* image_data_rgb;  // decoded image

/* load file to heap */
char*   load_file_inmem(char* fname, int32_t* read_sz);

void draw_window()
{
    int pos_x = 5, pos_y = get_skin_height();  
	BeginDraw();
	DrawWindow(10, 40, 600, 400, "My window", 0xFFFFFF, 0x13);

	draw_bitmap(image_data_rgb, pos_x, pos_y, 2400, 2000);
    EndDraw();
}

int main(int argc, char **argv)
{
    if (kolibri_libimg_init() == -1)  // png handling
    {
		printf("Can not load LIBIMG!\n");
		exit(1);
	}

    // load image 
    const int icon_rgb_size = 2400*2000; // file demo is 2400x2000x8bpp
    char *image_data,
         *filedata;
    // make full path + argv
    strcpy(temp_path, argv[0]);
    char *pc = strrchr(temp_path, '/');  
    if (pc) pc[1] = 0;
    strcat(temp_path, "cxx_price.png");

    int32_t read_bytes;
    filedata = load_file_inmem(temp_path, &read_bytes);
    image_data_rgb = malloc(icon_rgb_size * 3);  // we know size, 8bpp
    // определяем вид изображения и переводим его во временный буфер image_data
    image_data = img_decode(filedata, read_bytes, 0); 
    // преобразуем изображение к формату rgb
    img_to_rgb2(image_data, image_data_rgb);
    // удаляем временный буфер image_data
    img_destroy(image_data);
    free(filedata);
    
    while (1) {
		switch(get_os_event())
		{
		case 1:
			draw_window();
			break;
		case 3:
			if (get_os_button() == 1) exit(0);
			break;
		}
	}
	

	return 0;
}

char*   load_file_inmem(char* fname, int32_t* read_sz)
{
    FILE *f = fopen(fname, "rb");
    if (!f) {
        exit(1);
    }
    if (fseek(f, 0, SEEK_END)) {
        exit(1);
    }
    int filesize = ftell(f);
    rewind(f);
    char* fdata = malloc(filesize);
    if(!fdata) {
        exit(1);
    }
    *read_sz = fread(fdata, 1, filesize, f);
    if (ferror(f)) {
        exit(1);
    }
    fclose(f);

    return fdata;
}
